package be.iminds.ilabt.jfed.espec.model;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

/**
 * ESpecConfig global config options specified in an ExperimentSpecification
 *
 *
 */
public class ESpecConfig {
    private final boolean useSudoByDefault;
    /**
     * null means specify no sudo user (which implies root)
     */
    @Nullable private final String defaultSudoUser;

    private final boolean storeRemoteLogsByDefault;
    private final boolean storeLocalLogsByDefault;

    private final boolean includeAnsibleNodeInAllNodes;

    public ESpecConfig(boolean useSudoByDefault, @Nullable String defaultSudoUser, boolean storeRemoteLogsByDefault, boolean storeLocalLogsByDefault, boolean includeAnsibleNodeInAllNodes) {
        this.useSudoByDefault = useSudoByDefault;
        this.defaultSudoUser = defaultSudoUser;
        this.storeRemoteLogsByDefault = storeRemoteLogsByDefault;
        this.storeLocalLogsByDefault = storeLocalLogsByDefault;
        this.includeAnsibleNodeInAllNodes = includeAnsibleNodeInAllNodes;
    }

    public boolean isUseSudoByDefault() {
        return useSudoByDefault;
    }

    @Nullable
    public String getDefaultSudoUser() {
        return defaultSudoUser;
    }

    public boolean isStoreRemoteLogsByDefault() {
        return storeRemoteLogsByDefault;
    }

    public boolean isStoreLocalLogsByDefault() {
        return storeLocalLogsByDefault;
    }

    public boolean isIncludeAnsibleNodeInAllNodes() {
        return includeAnsibleNodeInAllNodes;
    }
}
