package be.iminds.ilabt.jfed.experimenter_gui.preferences.subsections;

import be.iminds.ilabt.jfed.experimenter_gui.preferences.AbstractPreferencesSubPane;
import be.iminds.ilabt.jfed.preferences.GuiPreferenceKey;
import be.iminds.ilabt.jfed.preferences.JFedGuiPreferences;
import be.iminds.ilabt.jfed.ssh_terminal_tool.unix.TerminalFinder;
import be.iminds.ilabt.jfed.ui.javafx.dialogs.JFDialogs;
import be.iminds.ilabt.jfed.util.OSDetector;
import be.iminds.ilabt.jfed.util.tmp_file_helpers.TmpContentFile;
import javafx.fxml.FXML;
import javafx.scene.Node;
import javafx.scene.control.Label;
import javafx.scene.control.TextArea;
import javafx.scene.layout.BorderPane;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.inject.Inject;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Objects;
import java.util.regex.Pattern;

/**
 * TerminalCommandPanel
 */
public class RDPPane extends AbstractPreferencesSubPane {
    private final static Logger LOG = LoggerFactory.getLogger(RDPPane.class);

    @FXML protected TextArea rdpCommandTextArea;
    @FXML private Label rdpCommandLabel;
    @FXML
    private BorderPane root;

    private final JFedGuiPreferences jFedPreferences;

    @Override
    public Node getRoot() {
        return root;
    }

    @Inject
    RDPPane(JFedGuiPreferences jFedPreferences) {
        super("Windows Remote Desktop", false);
        this.jFedPreferences = jFedPreferences;
    }

    @FXML
    private void initialize() {
        if (OSDetector.findOS() == OSDetector.OS.MAC) {
//            rdpCommandLabel.setText("AppleScript commands:");
        }


        if (jFedPreferences.getString(GuiPreferenceKey.PREF_COMMAND_RDP) != null)
            rdpCommandTextArea.setText(jFedPreferences.getString(GuiPreferenceKey.PREF_COMMAND_RDP));
    }

    @Override
    public boolean check() {
//        if (!rdpCommandTextArea.getText().contains("%h")) {
//            JFDialogs.create()
//                    .owner(root)
//                    .message("Your terminal command must contain '%h'")
//                    .showError();
//            return false;
//        }
//        if (!rdpCommandTextArea.getText().contains("%p")) {
//            JFDialogs.create()
//                    .owner(root)
//                    .message("Your terminal command must contain '%p'")
//                    .showError();
//            return false;
//        }

        return true;
    }
    @Override
    public boolean save() {
        jFedPreferences.setString(GuiPreferenceKey.PREF_COMMAND_RDP, rdpCommandTextArea.getText());

        return true;
    }
}
